package org.log4jfugue;

import org.apache.log4j.Logger;

public class LogMaker {
	static Logger log = Logger.getLogger(LogMaker.class);
	
	// write a specified number of log messages, with a
	// given distribution of messages
	static void doSome(int percents[], String msgs[], int msgsPerSecond, int numSeconds) {
		for(int seconds = 0; seconds < numSeconds; seconds++) {
			for(int x=0; x< msgsPerSecond; x++) {
				int thisValue = (int)(100 * Math.random());
				int total = 0;
				int whichMsg = 0;
				for(int y=0; y < msgs.length; y++) {
					if( thisValue < (total+percents[y])) {
						whichMsg = y;
						break;
					}
					total += percents[y];
				}
				log.info(msgs[whichMsg]);
			}
			try {
				Thread.sleep(1000);
			}catch(Exception ex) {
				log.error("got ", ex);
			}
		}
	}
	public static void main(String[] args) {
		String streamDestroy = "destroyImpl";
		String streamFailure = "MasterAgentTrap";
		String failure2 = "ERROR";
		doSome(new int[] {50,50}, new String[] {"response to stream create", streamDestroy}, 2, 10);
		doSome(new int[] {50,50}, new String[] {"response to stream create", streamDestroy}, 4, 10);
		doSome(new int[] {50,50}, new String[] {"response to stream create", streamDestroy}, 6, 5);
		doSome(new int[] {50,50}, new String[] {"response to stream create", streamDestroy}, 8, 5);
		doSome(new int[] {45,45,10}, new String[] {"response to stream create", streamDestroy, streamFailure}, 10, 10);
		doSome(new int[] {35,35,30}, new String[] {"response to stream create", streamDestroy, streamFailure}, 10, 10);
		doSome(new int[] {25,25,25,25}, new String[] {"response to stream create", streamDestroy, streamFailure, failure2}, 10, 10);
		doSome(new int[] {50,50}, new String[] {"response to stream create", streamDestroy}, 8, 25);
	}
}
