/*
 * Log4JFugue - Application Sonification
 * Copyright (C) 2008-2009  Brian Tarbox
 *
 * http://www.log4jfugue.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

package org.log4jfugue;
import java.io.BufferedReader;
import java.io.FileReader;

import org.apache.log4j.Logger;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.*;


/**
 * A statistics app using the Log4JFugue framework
 * It builds up the time based counts for various strings but
 * then outputs a csv file instead of music strings
 */
public class LogStats {
	Logger log = Logger.getLogger(LogStats.class);
  

	public static void main(String[] args) {
		String fileToProcess = null;
		if((null != args) && (args.length > 0)) {
			fileToProcess = args[0];
		}
		try {
			System.out.println("at start");
			BufferedReader reader = null;
			try {
				System.out.println("about to open " + fileToProcess);
				reader = new BufferedReader(new FileReader(fileToProcess));
				System.out.println("opened " + fileToProcess);
			}catch(Exception ex) {
				System.out.println("exception opening file " + ex);
			}finally {
				reader.close();
			}

			ApplicationContext appContext = new ClassPathXmlApplicationContext("spring-log4jfugue.xml");
			System.out.println("after got appContext");

			MessageReceiver mr = (MessageReceiver)appContext.getBean("messageReceiver");
			SimpleDataGetter dg = (SimpleDataGetter)appContext.getBean("dataGetter");
			System.out.println("after got beans");

			System.out.println("about to start MessageReceiver thread");
			mr.start();

			if((null != fileToProcess) && (dg instanceof FileDataGetter)){
				((FileDataGetter)dg).setFileName(fileToProcess);  // override injected name
			}
			System.out.println("about to start data getter thread");
			dg.start();
		}catch(Exception ex) {
			System.out.println("Exception " );
			ex.printStackTrace();
		}
	}

}